--- u-boot-2011.06_original/drivers/mmc/mmc.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mmc/mmc.c	2014-07-29 17:28:38.819972000 +0800
@@ -1151,7 +1337,144 @@
 	if (board_mmc_init(bis) < 0)
 		cpu_mmc_init(bis);
 
+#ifndef CONFIG_SPL_BUILD
 	print_mmc_devices(',');
+#endif
+
+	do_preinit();
+	return 0;
+}
+
+#ifdef CONFIG_SUPPORT_EMMC_BOOT
+/*
+ * This function changes the size of boot partition and the size of rpmb
+ * partition present on EMMC devices.
+ *
+ * Input Parameters:
+ * struct *mmc: pointer for the mmc device strcuture
+ * bootsize: size of boot partition
+ * rpmbsize: size of rpmb partition
+ *
+ * Returns 0 on success.
+ */
+
+int mmc_boot_partition_size_change(struct mmc *mmc, unsigned long bootsize,
+				unsigned long rpmbsize)
+{
+	int err;
+	struct mmc_cmd cmd;
+
+	/* Only use this command for raw EMMC moviNAND. Enter backdoor mode */
+	cmd.cmdidx = MMC_CMD_RES_MAN;
+	cmd.resp_type = MMC_RSP_R1b;
+	cmd.cmdarg = MMC_CMD62_ARG1;
+
+	err = mmc_send_cmd(mmc, &cmd, NULL);
+	if (err) {
+		debug("mmc_boot_partition_size_change: Error1 = %d\n", err);
+		return err;
+	}
+
+	/* Boot partition changing mode */
+	cmd.cmdidx = MMC_CMD_RES_MAN;
+	cmd.resp_type = MMC_RSP_R1b;
+	cmd.cmdarg = MMC_CMD62_ARG2;
+
+	err = mmc_send_cmd(mmc, &cmd, NULL);
+	if (err) {
+		debug("mmc_boot_partition_size_change: Error2 = %d\n", err);
+		return err;
+	}
+	/* boot partition size is multiple of 128KB */
+	bootsize = (bootsize * 1024) / 128;
+
+	/* Arg: boot partition size */
+	cmd.cmdidx = MMC_CMD_RES_MAN;
+	cmd.resp_type = MMC_RSP_R1b;
+	cmd.cmdarg = bootsize;
+
+	err = mmc_send_cmd(mmc, &cmd, NULL);
+	if (err) {
+		debug("mmc_boot_partition_size_change: Error3 = %d\n", err);
+		return err;
+	}
+	/* RPMB partition size is multiple of 128KB */
+	rpmbsize = (rpmbsize * 1024) / 128;
+	/* Arg: RPMB partition size */
+	cmd.cmdidx = MMC_CMD_RES_MAN;
+	cmd.resp_type = MMC_RSP_R1b;
+	cmd.cmdarg = rpmbsize;
 
+	err = mmc_send_cmd(mmc, &cmd, NULL);
+	if (err) {
+		debug("mmc_boot_partition_size_change: Error4 = %d\n", err);
+		return err;
+	}
 	return 0;
 }
+
+/*
+ * This function shall form and send the commands to open / close the
+ * boot partition specified by user.
+ *
+ * Input Parameters:
+ * ack: 0x0 - No boot acknowledge sent (default)
+ *	0x1 - Boot acknowledge sent during boot operation
+ * part_num: User selects boot data that will be sent to master
+ *	0x0 - Device not boot enabled (default)
+ *	0x1 - Boot partition 1 enabled for boot
+ *	0x2 - Boot partition 2 enabled for boot
+ * access: User selects partitions to access
+ *	0x0 : No access to boot partition (default)
+ *	0x1 : R/W boot partition 1
+ *	0x2 : R/W boot partition 2
+ *	0x3 : R/W Replay Protected Memory Block (RPMB)
+ *
+ * Returns 0 on success.
+ */
+int mmc_boot_part_access(struct mmc *mmc, u8 ack, u8 part_num, u8 access)
+{
+	int err;
+	struct mmc_cmd cmd;
+
+	/* Boot ack enable, boot partition enable , boot partition access */
+	cmd.cmdidx = MMC_CMD_SWITCH;
+	cmd.resp_type = MMC_RSP_R1b;
+
+	cmd.cmdarg = (MMC_SWITCH_MODE_WRITE_BYTE << 24) |
+			(EXT_CSD_PART_CONF << 16) |
+			((EXT_CSD_BOOT_ACK(ack) |
+			EXT_CSD_BOOT_PART_NUM(part_num) |
+			EXT_CSD_PARTITION_ACCESS(access)) << 8);
+
+	err = mmc_send_cmd(mmc, &cmd, NULL);
+	if (err) {
+		if (access) {
+			debug("mmc boot partition#%d open fail:Error1 = %d\n",
+			      part_num, err);
+		} else {
+			debug("mmc boot partition#%d close fail:Error = %d\n",
+			      part_num, err);
+		}
+		return err;
+	}
+
+	if (access) {
+		/* 4bit transfer mode at booting time. */
+		cmd.cmdidx = MMC_CMD_SWITCH;
+		cmd.resp_type = MMC_RSP_R1b;
+
+		cmd.cmdarg = (MMC_SWITCH_MODE_WRITE_BYTE << 24) |
+				(EXT_CSD_BOOT_BUS_WIDTH << 16) |
+				((1 << 0) << 8);
+
+		err = mmc_send_cmd(mmc, &cmd, NULL);
+		if (err) {
+			debug("mmc boot partition#%d open fail:Error2 = %d\n",
+			      part_num, err);
+			return err;
+		}
+	}
+	return 0;
+}
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mmc/mmc_private.h u-boot-2011.06/drivers/mmc/mmc_private.h
--- u-boot-2011.06_original/drivers/mmc/mmc_private.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mmc/mmc_private.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,45 @@
+/*
+ * Copyright 2008,2010 Freescale Semiconductor, Inc
+ * Andy Fleming
+ *
+ * Based (loosely) on the Linux code
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+
+#ifndef _MMC_PRIVATE_H_
+#define _MMC_PRIVATE_H_
+
+#include <mmc.h>
+
+extern int mmc_send_cmd(struct mmc *mmc, struct mmc_cmd *cmd,
+			struct mmc_data *data);
+extern int mmc_send_status(struct mmc *mmc, int timeout);
+extern int mmc_set_blocklen(struct mmc *mmc, int len);
+
+#ifndef CONFIG_SPL_BUILD
+
+extern unsigned long mmc_berase(int dev_num, lbaint_t start, lbaint_t blkcnt);
+
+extern ulong mmc_bwrite(int dev_num, lbaint_t start, lbaint_t blkcnt,
+		const void *src);
+
+#else /* CONFIG_SPL_BUILD */
+
+/* SPL will never write or erase, declare dummies to reduce code size. */
+
+static inline unsigned long mmc_berase(int dev_num, lbaint_t start,
+		lbaint_t blkcnt)
+{
+	return 0;
+}
+
+static inline ulong mmc_bwrite(int dev_num, lbaint_t start, lbaint_t blkcnt,
+		const void *src)
+{
+	return 0;
+}
+
+#endif /* CONFIG_SPL_BUILD */
+
+#endif /* _MMC_PRIVATE_H_ */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mmc/mmc_write.c u-boot-2011.06/drivers/mmc/mmc_write.c
--- u-boot-2011.06_original/drivers/mmc/mmc_write.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mmc/mmc_write.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,179 @@
+/*
+ * Copyright 2008, Freescale Semiconductor, Inc
+ * Andy Fleming
+ *
+ * Based vaguely on the Linux code
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+
+#include <config.h>
+#include <common.h>
+#include <part.h>
+#include "mmc_private.h"
+
+static ulong mmc_erase_t(struct mmc *mmc, ulong start, lbaint_t blkcnt)
+{
+	struct mmc_cmd cmd;
+	ulong end;
+	int err, start_cmd, end_cmd;
+
+	if (mmc->high_capacity) {
+		end = start + blkcnt - 1;
+	} else {
+		end = (start + blkcnt - 1) * mmc->write_bl_len;
+		start *= mmc->write_bl_len;
+	}
+
+	if (IS_SD(mmc)) {
+		start_cmd = SD_CMD_ERASE_WR_BLK_START;
+		end_cmd = SD_CMD_ERASE_WR_BLK_END;
+	} else {
+		start_cmd = MMC_CMD_ERASE_GROUP_START;
+		end_cmd = MMC_CMD_ERASE_GROUP_END;
+	}
+
+	cmd.cmdidx = start_cmd;
+	cmd.cmdarg = start;
+	cmd.resp_type = MMC_RSP_R1;
+
+	err = mmc_send_cmd(mmc, &cmd, NULL);
+	if (err)
+		goto err_out;
+
+	cmd.cmdidx = end_cmd;
+	cmd.cmdarg = end;
+
+	err = mmc_send_cmd(mmc, &cmd, NULL);
+	if (err)
+		goto err_out;
+
+	cmd.cmdidx = MMC_CMD_ERASE;
+	cmd.cmdarg = SECURE_ERASE;
+	cmd.resp_type = MMC_RSP_R1b;
+
+	err = mmc_send_cmd(mmc, &cmd, NULL);
+	if (err)
+		goto err_out;
+
+	return 0;
+
+err_out:
+	puts("mmc erase failed\n");
+	return err;
+}
+
+unsigned long mmc_berase(int dev_num, lbaint_t start, lbaint_t blkcnt)
+{
+	int err = 0;
+	struct mmc *mmc = find_mmc_device(dev_num);
+	lbaint_t blk = 0, blk_r = 0;
+	int timeout = 1000;
+
+	if (!mmc)
+		return -1;
+
+	if ((start % mmc->erase_grp_size) || (blkcnt % mmc->erase_grp_size))
+		printf("\n\nCaution! Your devices Erase group is 0x%x\n"
+		       "The erase range would be change to "
+		       "0x" LBAF "~0x" LBAF "\n\n",
+		       mmc->erase_grp_size, start & ~(mmc->erase_grp_size - 1),
+		       ((start + blkcnt + mmc->erase_grp_size)
+		       & ~(mmc->erase_grp_size - 1)) - 1);
+
+	while (blk < blkcnt) {
+		blk_r = ((blkcnt - blk) > mmc->erase_grp_size) ?
+			mmc->erase_grp_size : (blkcnt - blk);
+		err = mmc_erase_t(mmc, start + blk, blk_r);
+		if (err)
+			break;
+
+		blk += blk_r;
+
+		/* Waiting for the ready status */
+		if (mmc_send_status(mmc, timeout))
+			return 0;
+	}
+
+	return blk;
+}
+
+static ulong mmc_write_blocks(struct mmc *mmc, lbaint_t start,
+		lbaint_t blkcnt, const void *src)
+{
+	struct mmc_cmd cmd;
+	struct mmc_data data;
+	int timeout = 1000;
+
+	if ((start + blkcnt) > mmc->block_dev.lba) {
+		printf("MMC: block number 0x" LBAF " exceeds max(0x" LBAF ")\n",
+		       start + blkcnt, mmc->block_dev.lba);
+		return 0;
+	}
+
+	if (blkcnt == 0)
+		return 0;
+	else if (blkcnt == 1)
+		cmd.cmdidx = MMC_CMD_WRITE_SINGLE_BLOCK;
+	else
+		cmd.cmdidx = MMC_CMD_WRITE_MULTIPLE_BLOCK;
+
+	if (mmc->high_capacity)
+		cmd.cmdarg = start;
+	else
+		cmd.cmdarg = start * mmc->write_bl_len;
+
+	cmd.resp_type = MMC_RSP_R1;
+
+	data.src = src;
+	data.blocks = blkcnt;
+	data.blocksize = mmc->write_bl_len;
+	data.flags = MMC_DATA_WRITE;
+
+	if (mmc_send_cmd(mmc, &cmd, &data)) {
+		printf("mmc write failed\n");
+		return 0;
+	}
+
+	/* SPI multiblock writes terminate using a special
+	 * token, not a STOP_TRANSMISSION request.
+	 */
+	if (!mmc_host_is_spi(mmc) && blkcnt > 1) {
+		cmd.cmdidx = MMC_CMD_STOP_TRANSMISSION;
+		cmd.cmdarg = 0;
+		cmd.resp_type = MMC_RSP_R1b;
+		if (mmc_send_cmd(mmc, &cmd, NULL)) {
+			printf("mmc fail to send stop cmd\n");
+			return 0;
+		}
+	}
+
+	/* Waiting for the ready status */
+	if (mmc_send_status(mmc, timeout))
+		return 0;
+
+	return blkcnt;
+}
+
+ulong mmc_bwrite(int dev_num, lbaint_t start, lbaint_t blkcnt, const void *src)
+{
+	lbaint_t cur, blocks_todo = blkcnt;
+
+	struct mmc *mmc = find_mmc_device(dev_num);
+	if (!mmc)
+		return 0;
+
+	if (mmc_set_blocklen(mmc, mmc->write_bl_len))
+		return 0;
+
+	do {
+		cur = (blocks_todo > mmc->b_max) ?  mmc->b_max : blocks_todo;
+		if (mmc_write_blocks(mmc, start, cur, src) != cur)
+			return 0;
+		blocks_todo -= cur;
+		start += cur;
+		src += cur * mmc->write_bl_len;
+	} while (blocks_todo > 0);
+
+	return blkcnt;
+}
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mmc/mshci.h u-boot-2011.06/drivers/mmc/mshci.h
--- u-boot-2011.06_original/drivers/mmc/mshci.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mmc/mshci.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,324 @@
+/*
+ * (C) Copyright 2011 Cavium Inc.
+ * Scott Shu <sshu@caviumnetworks.com>
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#ifndef _CNS3000_MMC_H
+#define _CNS3000_MMC_H
+
+/* MSHC Internal Registers */
+#define MSHCI_CTRL	0x00	/* Control */
+#define MSHCI_PWREN	0x04   	/* Power-enable */
+#define MSHCI_CLKDIV	0x08   	/* Clock divider */
+#define MSHCI_CLKSRC	0x0C   	/* Clock source */
+#define MSHCI_CLKENA	0x10	/* Clock enable */
+#define MSHCI_TMOUT	0x14	/* Timeout */
+#define MSHCI_CTYPE	0x18	/* Card type */
+#define MSHCI_BLKSIZ	0x1C	/* Block Size */
+#define MSHCI_BYTCNT	0x20	/* Byte count */
+#define MSHCI_INTMSK	0x24	/* Interrupt Mask */
+#define MSHCI_CMDARG	0x28	/* Command Argument */
+#define MSHCI_CMD	0x2C	/* Command */
+#define MSHCI_RESP0	0x30	/* Response 0 */
+#define MSHCI_RESP1	0x34	/* Response 1 */
+#define MSHCI_RESP2	0x38	/* Response 2 */
+#define MSHCI_RESP3	0x3C	/* Response 3 */
+#define MSHCI_MINTSTS	0x40	/* Masked interrupt status */
+#define MSHCI_RINTSTS	0x44	/* Raw interrupt status */
+#define MSHCI_STATUS	0x48	/* Status */
+#define MSHCI_FIFOTH	0x4C	/* FIFO threshold */
+#define MSHCI_CDETECT	0x50	/* Card detect */
+#define MSHCI_WRTPRT	0x54	/* Write protect */
+#define MSHCI_GPIO	0x58	/* General Purpose IO */
+#define MSHCI_TCBCNT	0x5C	/* Transferred CIU byte count */
+#define MSHCI_TBBCNT	0x60	/* Transferred host/DMA to/from byte count */
+#define MSHCI_DEBNCE	0x64	/* Card detect debounce */
+#define MSHCI_USRID	0x68	/* User ID */
+#define MSHCI_VERID	0x6C	/* Version ID */
+#define MSHCI_HCON	0x70	/* Hardware Configuration */
+#define MSHCI_UHS_REG	0x74	/* UHS and DDR setting */
+#define MSHCI_BMOD	0x80    /* Bus mode register */
+#define MSHCI_PLDMND	0x84    /* Poll demand */
+#define MSHCI_DBADDR	0x88    /* Descriptor list base address */
+#define MSHCI_IDSTS	0x8C    /* Internal DMAC status */
+#define MSHCI_IDINTEN	0x90    /* Internal DMAC interrupt enable */
+#define MSHCI_DSCADDR	0x94    /* Current host descriptor address */
+#define MSHCI_BUFADDR	0x98    /* Current host buffer address */
+#define MSHCI_CLKSEL	0x9C
+#define MSHCI_WAKEUPCON	0xA0    /* Wakeup control register */
+#define MSHCI_CLOCKCON	0xA4    /* Clock (delay) control register */
+#define MSHCI_UHS_REG_EXT	0x108
+#define MSHCI_FIFODAT	0x200	/* FIFO data read write */
+
+#define SDMMC_UHS_EXT_DRV_SHIFT 23
+#define SDMMC_UHS_EXT_SMP_SHIFT 16
+
+/* Control Register Register (0x00) */
+#define CTRL_RESET	(0x1<<0)	/* Reset DWC_mobile_storage controller */	
+#define FIFO_RESET	(0x1<<1)	/* Reset FIFO */
+#define DMA_RESET	(0x1<<2)	/* Reset DMA interface */
+#define INT_ENABLE	(0x1<<4)	/* Global interrupt enable/disable bit */
+#define DMA_ENABLE	(0x1<<5)	/* DMA transfer mode enable/disable bit */
+#define READ_WAIT	(0x1<<6)	/* For sending read-wait to SDIO cards */
+#define SEND_IRQ_RESP	(0x1<<7)	/* Send auto IRQ response */
+#define ABRT_READ_DATA	(0x1<<8)	
+#define SEND_CCSD	(0x1<<9)
+#define SEND_AS_CCSD	(0x1<<10)
+#define CEATA_INTSTAT	(0x1<<11)
+#define CARD_VOLA	(0xF<<16)
+#define CARD_VOLB	(0xF<<20)
+#define ENABLE_OD_PULLUP (0x1<<24)	
+#define ENABLE_IDMAC    (0x1<<25)
+
+#define MSHCI_RESET_ALL	(0x1)
+
+/* Power Enable Register (0x04) */
+#define POWER_ENABLE	(0x1<<0)
+
+/* Clock Divider Register (0x08) */
+#define CLK_DIVIDER0	(0xFF<<0)
+#define CLK_DIVIDER1	(0xFF<<8)
+#define	CLK_DIVIDER2	(0xFF<<16)
+#define CLK_DIVIDER3	(0xFF<<24)
+
+/* Clock Enable Register (0x10) */
+#define CLK_SDMMC_MAX	(48000000)
+#define CLK_ENABLE	(0x1<<0)
+#define CLK_DISABLE	(0x0<<0)
+
+/* Timeout  Register (0x14) */
+#define RSP_TIMEOUT	(0xFF<<0)
+#define DATA_TIMEOUT	(0xFFFFFF<<8)
+
+/* Card Type Register (0x18) */
+#define CARD_WIDTH4	(0xFFFF<<0)
+#define CARD_WIDTH8	(0xFFFF<<16)
+
+/* Block Size Register (0x1C) */
+#define BLK_SIZ		(0xFFFF<<0)
+
+/* Interrupt Mask Register (0x24) */
+#define INT_MASK	(0xFFFF<<0)
+#define	SDIO_INT_MASK	(0xFFFF<<16)
+#define SDIO_INT_ENABLE (0x1<<16)
+
+/* interrupt bits */
+#define INTMSK_ALL	0xFFFFFFFF
+#define INTMSK_CDETECT 	(0x1<<0) 
+#define INTMSK_RE	(0x1<<1)
+#define INTMSK_CDONE 	(0x1<<2)
+#define INTMSK_DTO	(0x1<<3)
+#define INTMSK_TXDR     (0x1<<4)
+#define INTMSK_RXDR     (0x1<<5)
+#define INTMSK_RCRC     (0x1<<6)
+#define INTMSK_DCRC     (0x1<<7)
+#define INTMSK_RTO      (0x1<<8)
+#define INTMSK_DRTO    	(0x1<<9) 
+#define INTMSK_HTO      (0x1<<10)
+#define INTMSK_FRUN     (0x1<<11)
+#define INTMSK_HLE      (0x1<<12)
+#define INTMSK_SBE      (0x1<<13)
+#define INTMSK_ACD      (0x1<<14)
+#define INTMSK_EBE	(0x1<<15)
+#define INTMSK_DMA	(INTMSK_ACD|INTMSK_RXDR|INTMSK_TXDR)
+
+#define INT_SRC_IDMAC   (0x0)
+#define INT_SRC_MINT    (0x1)
+
+
+/* Command Register (0x2C) */
+#define CMD_RESP_EXP_BIT	(0x1<<6)	
+#define CMD_RESP_LENGTH_BIT	(0x1<<7)
+#define CMD_CHECK_CRC_BIT	(0x1<<8)
+#define CMD_DATA_EXP_BIT	(0x1<<9)
+#define CMD_RW_BIT		(0x1<<10)
+#define CMD_TRANSMODE_BIT	(0x1<<11)
+#define CMD_SENT_AUTO_STOP_BIT	(0x1<<12)
+#define CMD_WAIT_PRV_DAT_BIT	(0x1<<13)
+#define CMD_ABRT_CMD_BIT	(0x1<<14)
+#define CMD_SEND_INIT_BIT	(0x1<<15)
+#define CMD_CARD_NUM_BITS	(0x1F<<16)
+#define CMD_SEND_CLK_ONLY	(0x1<<21)
+#define CMD_READ_CEATA		(0x1<<22)
+#define CMD_CCS_EXPECTED	(0x1<<23)
+#define CMD_STRT_BIT		(0x1<<31)
+#define CMD_ONLY_CLK		(CMD_STRT_BIT | CMD_SEND_CLK_ONLY | \
+						CMD_WAIT_PRV_DAT_BIT)
+/* Masked Interrupt Status Register (0x40) */
+
+/* Raw Interrupt Register (0x44) */
+#define INT_STATUS	(0xFFFF<<0)
+#define SDIO_INTR	(0xFFFF<<16)
+#define DATA_ERR	(INTMSK_EBE|INTMSK_SBE|INTMSK_HLE|INTMSK_FRUN |\
+					INTMSK_EBE |INTMSK_DCRC)
+#define DATA_TOUT	(INTMSK_HTO|INTMSK_DRTO)
+#define DATA_STATUS	(DATA_ERR|DATA_TOUT|INTMSK_RXDR|INTMSK_TXDR|INTMSK_DTO)
+#define CMD_STATUS	(INTMSK_RTO|INTMSK_RCRC|INTMSK_CDONE|INTMSK_RE)
+#define CMD_ERROR       (INTMSK_RCRC|INTMSK_RTO|INTMSK_RE)
+
+/* Status Register (0x48) */
+#define FIFO_RXWTRMARK	(0x1<<0)
+#define FIFO_TXWTRMARK	(0x1<<1)
+#define FIFO_EMPTY	(0x1<<2)
+#define FIFO_FULL	(0x1<<3)
+#define CMD_FSMSTAT	(0xF<<4)
+#define	DATA_3STATUS	(0x1<<8)
+#define DATA_BUSY	(0x1<<9)
+#define DATA_MCBUSY	(0x1<<10)
+#define RSP_INDEX	(0x3F<<11)
+#define FIFO_COUNT	(0x1FFF<<17)
+#define	DMA_ACK		(0x1<<30)
+#define	DMA_REQ		(0x1<<31)
+#define FIFO_WIDTH 	(0x4)
+#define FIFO_DEPTH      (0x20)
+
+/*Command FSM status */
+#define FSM_IDLE		(0 <<4)          		
+#define FSM_SEND_INIT_SEQ	(1 <<4)  
+#define FSM_TX_CMD_STARTBIT	(2 <<4)
+#define FSM_TX_CMD_TXBIT   	(3 <<4)
+#define	FSM_TX_CMD_INDEX_ARG	(4 <<4)
+#define	FSM_TX_CMD_CRC7		(5 <<4)
+#define FSM_TX_CMD_ENDBIT	(6 <<4)
+#define	FSM_RX_RESP_STARTBIT	(7 <<4)
+#define FSM_RX_RESP_IRQRESP	(8 <<4)
+#define FSM_RX_RESP_TXBIT	(9 <<4)
+#define FSM_RX_RESP_CMDIDX	(10<<4)
+#define FSM_RX_RESP_DATA	(11<<4)
+#define FSM_RX_RESP_CRC7	(12<<4)
+#define FSM_RX_RESP_ENDBIT	(13<<4)
+#define FSM_CMD_PATHWAITNCC	(14<<4)
+#define FSM_WAIT		(15<<4)
+
+/* FIFO Threshold Watermark Register (0x4C) */
+#define TX_WMARK		(0xFFF<<0)
+#define RX_WMARK		(0xFFF<<16)
+#define MSIZE_MASK		(0x7<<28)
+
+/* DW DMA Mutiple Transaction Size */
+#define MSIZE_1			(0<<28)
+#define MSIZE_4			(1<<28)
+#define MSIZE_8			(2<<28)
+#define MSIZE_16		(3<<28)
+#define MSIZE_32		(4<<28)
+#define MSIZE_64		(5<<28)		
+#define MSIZE_128		(6<<28)
+#define MSIZE_256		(7<<28)
+
+/* FIFO Threshold Watermark Register (0x4C) */
+#define GPI			(0xFF<<0)
+#define	GPO			(0xFFFF<<8)
+
+/* Card Detect Register (0x50) */
+#define CARD_PRESENT	(0x1<<0)
+
+/* Write Protect Register (0x54) */
+#define WRTPRT_ON	(0x1<<0)
+
+/* Bus Mode Register (0x80) */
+#define BMOD_IDMAC_RESET        (0x1<<0)
+#define BMOD_IDMAC_FB           (0x1<<1)
+#define BMOD_IDMAC_ENABLE       (0x1<<7)
+
+/* Hardware Configuration  Register (0x70) */
+#define CARD_TYPE		(0x1<<0)
+#define NUM_CARDS		(0x1F<<1)
+#define H_BUS_TYPE		(0x1<<6)
+#define H_DATA_WIDTH		(0x7<<7)
+#define H_ADDR_WIDTH		(0x3F<<10)
+#define DMA_INTERFACE		(0x3<<16)
+#define	GE_DMA_DATA_WIDTH	(0x7<<18)
+#define FIFO_RAM_INSIDE		(0x1<<21)
+#define UMPLEMENT_HOLD_REG	(0x1<<22)
+#define SET_CLK_FALSE_PATH	(0x1<<23)
+#define NUM_CLK_DIVIDER		(0x3<<24)
+
+/* Hardware Configuration  Register (0x8C) */
+#define IDSTS_FSM               (0xf<<13)
+#define IDSTS_EB                (0x7<<10)
+#define IDSTS_AIS               (0x1<<9)
+#define IDSTS_NIS               (0x1<<8)
+#define IDSTS_CES               (0x1<<5)
+#define IDSTS_DU                (0x1<<4)
+#define IDSTS_FBE               (0x1<<2)
+#define IDSTS_RI                (0x1<<1)
+#define IDSTS_TI                (0x1<<0)
+
+struct mshci_ops;
+
+struct mshci_idmac {
+        u32     des0;
+        u32     des1;
+        u32     des2;
+        u32     des3;
+#define MSHCI_IDMAC_OWN         (1<<31)
+#define MSHCI_IDMAC_ER          (1<<5)
+#define MSHCI_IDMAC_CH          (1<<4)
+#define MSHCI_IDMAC_FS          (1<<3)
+#define MSHCI_IDMAC_LD          (1<<2)
+#define MSHCI_IDMAC_DIC         (1<<1)
+#define INTMSK_IDMAC_ALL        (0x337)
+#define INTMSK_IDMAC_ERROR      (0x214)        
+};
+
+#ifndef __iomem
+#define __iomem
+#endif
+
+struct mshci_host {
+	/* Data set by hardware interface driver */
+	const char		*hw_name;	/* Hardware bus name */
+
+	int			irq;		/* Device IRQ */
+	void __iomem *		ioaddr;		/* Mapped address */
+
+	/* Internal data */
+	struct mmc		*mmc;		/* MMC structure */
+	u64			dma_mask;	/* custom DMA mask */
+
+	int			flags;		/* Host attributes */
+#define MSHCI_USE_IDMA		(1<<1)		/* Host is ADMA capable */
+#define MSHCI_REQ_USE_DMA	(1<<2)		/* Use DMA for this req. */
+#define MSHCI_DEVICE_DEAD	(1<<3)		/* Device unresponsive */
+
+
+	unsigned int		version;	/* SDHCI spec. version */
+
+	unsigned int		max_clk;	/* Max possible freq (MHz) */
+	unsigned int		timeout_clk;	/* Timeout freq (KHz) */
+
+	unsigned int		clock;		/* Current clock (MHz) */
+	unsigned short		power;		/* Current voltage */
+
+	dma_addr_t		adma_addr;	/* Mapped ADMA descr. table */
+};
+
+static inline void mshci_writel(struct mshci_host *host, u32 val, int reg)
+{
+	writel(val, host->ioaddr + reg);
+}
+
+static inline u32 mshci_readl(struct mshci_host *host, int reg)
+{
+	return readl(host->ioaddr + reg);
+}
+
+#endif /* _CNS3000_MMC_H */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/nand/cnc_nand.c u-boot-2011.06/drivers/mtd/nand/cnc_nand.c
--- u-boot-2011.06_original/drivers/mtd/nand/cnc_nand.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/nand/cnc_nand.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,161 @@
+/*
+ * (C) Copyright 2007 STMicroelectronics, <www.st.com>
+ * (C) Copyright 2009 Alessandro Rubini <rubini@unipv.it>
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+#include <nand.h>
+#include <asm/io.h>
+#include <linux/mtd/nand_ecc.h>
+
+#define CE0_CFG0 (CONFIG_CNC_NAND_BASE + 0x00)
+#define CE0_CFG1 (CONFIG_CNC_NAND_BASE + 0x04)
+#define CE0_CFG2 (CONFIG_CNC_NAND_BASE + 0x08)
+#define CE0_CFG3 (CONFIG_CNC_NAND_BASE + 0x0C)
+
+#define SMC_STAT (CONFIG_CNC_NAND_BASE + 0x30)
+#define SMC_MODE (CONFIG_CNC_NAND_BASE + 0x38)
+#define SMC_ECC_CODE (CONFIG_CNC_NAND_BASE + 0x40)
+#define SMC_ECC_CONT (CONFIG_CNC_NAND_BASE + 0x44)
+#define SMC_ECC_ADDR (CONFIG_CNC_NAND_BASE + 0x48)
+
+#define FORCE_CE_LOW 0x200
+#define STATUS_READY 0x001
+
+#define CFG0_16BIT 0x01000000
+
+#define MASK_ALE	(1 << 22)
+#define MASK_CLE	(1 << 21)
+
+static void cnc_nand_hwctl(struct mtd_info *mtd, int mode)
+{
+	struct nand_chip *nand = mtd->priv;
+
+	if (mode == NAND_ECC_READ)
+		__raw_writel((unsigned int)(nand->IO_ADDR_R), (volatile unsigned int *) SMC_ECC_ADDR);
+
+	if (mode == NAND_ECC_WRITE)
+		__raw_writel((unsigned int) (nand->IO_ADDR_W), (volatile unsigned int *) SMC_ECC_ADDR);
+}
+
+/*
+ * Read hardware ECC value and pack into three bytes
+ */
+static int cnc_nand_calculate(struct mtd_info *mtd,
+		const u_char *dat, u_char *ecc_code)
+{
+	unsigned int ecc = __raw_readl(SMC_ECC_CODE);
+
+	ecc_code[0] = (u_char)(ecc);
+	ecc_code[1] = (u_char)(ecc >> 8);
+	ecc_code[2] = (u_char)(ecc >> 16);
+	return 0;
+}
+
+static int cnc_nand_dev_ready(struct mtd_info *mtd)
+{
+	unsigned int st = __raw_readl(SMC_STAT);
+	return st & STATUS_READY;
+}
+
+static void cnc_nand_read_buf(struct mtd_info *mtd, u8 *buf, int len)
+{
+	struct nand_chip *nand = mtd->priv;
+
+	if (len % 4)
+		__raw_readsb((u32)nand->IO_ADDR_R, buf, len);
+	else
+		__raw_readsl((u32)nand->IO_ADDR_R, buf, len / 4);
+}
+
+static void cnc_nand_write_buf(struct mtd_info *mtd, const u8 *buf, int len)
+{
+	struct nand_chip *nand = mtd->priv;
+
+	if (len % 4)
+		__raw_writesb((u32)nand->IO_ADDR_W, buf, len);
+	else
+		__raw_writesl((u32)nand->IO_ADDR_W, buf, len / 4);
+}
+
+static void cnc_nand_cmd_ctrl(struct mtd_info *mtd, int cmd, unsigned int ctrl)
+{
+	struct nand_chip *nand = mtd->priv;
+	unsigned int addr = CONFIG_SYS_NAND_BASE;
+
+	if (ctrl & NAND_CTRL_CHANGE) {
+		if (ctrl & NAND_CLE)
+			addr |= MASK_CLE;
+		if (ctrl & NAND_ALE)
+			addr |= MASK_ALE;
+
+		nand->IO_ADDR_W = (void *)addr; 
+	}
+
+	if (cmd != NAND_CMD_NONE)
+		__raw_writeb(cmd, nand->IO_ADDR_W);
+}
+
+static void cnc_nand_select_chip(struct mtd_info *mtd, int chip)
+{
+	struct nand_chip *nand = mtd->priv;
+	unsigned int cfg0 = 0;
+
+	cfg0 = __raw_readl(CE0_CFG0);
+	if (nand->options & NAND_BUSWIDTH_16)
+		cfg0 |= CFG0_16BIT;
+	else
+		cfg0 &= ~CFG0_16BIT;
+
+	if (chip >= 0)
+		__raw_writel(cfg0 | FORCE_CE_LOW, CE0_CFG0);
+}
+
+static void cnc_nand_init(void)
+{
+
+}
+
+int board_nand_init(struct nand_chip *nand)
+{
+	nand->options = NAND_USE_FLASH_BBT;
+	nand->chip_delay = 5;
+
+	/* Set address of hardware control function */
+	nand->select_chip = cnc_nand_select_chip;
+	nand->cmd_ctrl	  = cnc_nand_cmd_ctrl;
+	nand->dev_ready	  = cnc_nand_dev_ready;
+
+	/* Speed up buffer I/O */
+	nand->read_buf    = cnc_nand_read_buf;
+	nand->write_buf   = cnc_nand_write_buf;
+
+	/* Use board-specific ECC config */
+	nand->ecc.mode      = NAND_ECC_HW;
+	nand->ecc.hwctl     = cnc_nand_hwctl;
+	nand->ecc.calculate = cnc_nand_calculate;
+	nand->ecc.correct   = nand_correct_data;
+	nand->ecc.size      = 512;
+	nand->ecc.bytes     = 3;
+
+	cnc_nand_init();
+	return 0;
+}
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/nand/erase u-boot-2011.06/drivers/mtd/nand/erase
--- u-boot-2011.06_original/drivers/mtd/nand/erase	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/nand/erase	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,24 @@
+info:1:nand_util.c:83:	const char *mtd_device = meminfo->name;
+info:2:nand_util.c:85:	struct nand_chip *chip = meminfo->priv;
+info:3:nand_util.c:87:	if ((opts->offset & (meminfo->writesize - 1)) != 0) {
+info:4:nand_util.c:96:	erase.len  = meminfo->erasesize;
+info:5:nand_util.c:98:	erase_length = lldiv(opts->length + meminfo->erasesize - 1,
+info:6:nand_util.c:99:			     meminfo->erasesize);
+info:7:nand_util.c:110:		struct nand_chip *priv_nand = meminfo->priv;
+info:8:nand_util.c:125:	     erase.addr += meminfo->erasesize) {
+info:9:nand_util.c:130:			int ret = meminfo->block_isbad(meminfo, erase.addr);
+info:10:nand_util.c:153:		result = meminfo->erase(meminfo, &erase);
+info:11:nand_util.c:168:			result = meminfo->write_oob(meminfo,
+info:12:nand_util.c:205:		struct nand_chip *priv_nand = meminfo->priv;
+nand_util.c:83:	const char *mtd_device = meminfo->name;
+nand_util.c:85:	struct nand_chip *chip = meminfo->priv;
+nand_util.c:87:	if ((opts->offset & (meminfo->writesize - 1)) != 0) {
+nand_util.c:96:	erase.len  = meminfo->erasesize;
+nand_util.c:98:	erase_length = lldiv(opts->length + meminfo->erasesize - 1,
+nand_util.c:99:			     meminfo->erasesize);
+nand_util.c:110:		struct nand_chip *priv_nand = meminfo->priv;
+nand_util.c:125:	     erase.addr += meminfo->erasesize) {
+nand_util.c:130:			int ret = meminfo->block_isbad(meminfo, erase.addr);
+nand_util.c:153:		result = meminfo->erase(meminfo, &erase);
+nand_util.c:168:			result = meminfo->write_oob(meminfo,
+nand_util.c:205:		struct nand_chip *priv_nand = meminfo->priv;
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/nand/info u-boot-2011.06/drivers/mtd/nand/info
--- u-boot-2011.06_original/drivers/mtd/nand/info	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/nand/info	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,12 @@
+nand_util.c:83:	const char *mtd_device = meminfo->name;
+nand_util.c:85:	struct nand_chip *chip = meminfo->priv;
+nand_util.c:87:	if ((opts->offset & (meminfo->writesize - 1)) != 0) {
+nand_util.c:96:	erase.len  = meminfo->erasesize;
+nand_util.c:98:	erase_length = lldiv(opts->length + meminfo->erasesize - 1,
+nand_util.c:99:			     meminfo->erasesize);
+nand_util.c:110:		struct nand_chip *priv_nand = meminfo->priv;
+nand_util.c:125:	     erase.addr += meminfo->erasesize) {
+nand_util.c:130:			int ret = meminfo->block_isbad(meminfo, erase.addr);
+nand_util.c:153:		result = meminfo->erase(meminfo, &erase);
+nand_util.c:168:			result = meminfo->write_oob(meminfo,
+nand_util.c:205:		struct nand_chip *priv_nand = meminfo->priv;
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/nand/Makefile u-boot-2011.06/drivers/mtd/nand/Makefile
--- u-boot-2011.06_original/drivers/mtd/nand/Makefile	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/nand/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -33,6 +33,7 @@
 COBJS-y += nand_ids.o
 COBJS-y += nand_util.o
 
+COBJS-$(CONFIG_CNC_NAND) += cnc_nand.o
 COBJS-$(CONFIG_NAND_ATMEL) += atmel_nand.o
 COBJS-$(CONFIG_DRIVER_NAND_BFIN) += bfin_nand.o
 COBJS-$(CONFIG_NAND_DAVINCI) += davinci_nand.o
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/nand/nand_base.c u-boot-2011.06/drivers/mtd/nand/nand_base.c
--- u-boot-2011.06_original/drivers/mtd/nand/nand_base.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/nand/nand_base.c	2014-07-29 17:28:38.819972000 +0800
@@ -88,8 +88,8 @@
 		   48, 49, 50, 51, 52, 53, 54, 55,
 		   56, 57, 58, 59, 60, 61, 62, 63},
 	.oobfree = {
-		{.offset = 2,
-		 .length = 38}}
+		{.offset = 0,
+		 .length = 40}}
 };
 
 static struct nand_ecclayout nand_oob_128 = {
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/nand/nand_base_profiling.c u-boot-2011.06/drivers/mtd/nand/nand_base_profiling.c
